/*
 * 服务中心
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ServiceCenterController : BaseController
    {
        public ServiceCenterController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 服务中心列表

        /// <summary>
        /// 根据条件查询服务中心列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ServiceCenter data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询服务中心列表

        /// <summary>
        /// 服务中心列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ServiceCenter data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Title", "2"); //标题
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("CategoryId", "0");

            string condition = "";

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ServiceCenter", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["CategoryId"] = RelationClass.GetColInfo(int.Parse(dic["CategoryId"].ToString()));
                dic["Status"] = dic["Status"].ToString() == "-1" ? "已删除" : "未删除";
            }
            return Json(obj);
        }

        #endregion

        #region 增加服务中心

        /// <summary>
        /// 增加或修改服务中心信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加服务中心

        /// <summary>
        /// 增加或修改服务中心信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ServiceCenter data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Title", data.Title); //标题
            Fields.Add("SubTitle", data.SubTitle); //副标题
            Fields.Add("Content", data.Content); //内容
            Fields.Add("CategoryId", data.CategoryId); //问答类型
            Fields.Add("CreateMan", SysUserName);

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ServiceCenter", Fields, 0);
            AddSysLog(Id.ToString(), "ServiceCenter", "add");
            db.SaveChanges();

            SetRedis(Id, data.CategoryId);

            return "success";
        }

        #endregion

        #region 修改服务中心

        /// <summary>
        /// 增加或修改服务中心信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            ServiceCenter editData = db.ServiceCenter.FirstOrDefault(m => m.Id == Id) ?? new ServiceCenter();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改服务中心

        /// <summary>
        /// 增加或修改服务中心信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ServiceCenter data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Title", data.Title); //标题
            Fields.Add("SubTitle", data.SubTitle); //副标题
            Fields.Add("Content", data.Content); //内容
            Fields.Add("CategoryId", data.CategoryId); //问答类型

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ServiceCenter", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "ServiceCenter", "update");
            db.SaveChanges();

            SetRedis(data.Id, data.CategoryId);

            return "success";
        }

        #endregion
        
        #region 详情

        public IActionResult Detail(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            ServiceCenter editData = db.ServiceCenter.FirstOrDefault(m => m.Id == Id) ?? new ServiceCenter();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 删除服务中心信息

        /// <summary>
        /// 删除服务中心信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ServiceCenter", "del");
            List<int> CategoryIds = new List<int>();
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                ServiceCenter item = db.ServiceCenter.FirstOrDefault(m => m.Id == id) ?? new ServiceCenter();
                if (!CategoryIds.Contains(item.CategoryId))
                {
                    CategoryIds.Add(item.CategoryId);
                }
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ServiceCenter", Fields, id);
            }
            db.SaveChanges();

            foreach (int CategoryId in CategoryIds)
            {
                SetRedis(0, CategoryId);
            }

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ServiceCenter", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ServiceCenter", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ServiceCenter", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ServiceCenter", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ServiceCenter", Sort, Id);

            AddSysLog(Id.ToString(), "ServiceCenter", "sort");

            ServiceCenter item = db.ServiceCenter.FirstOrDefault(m => m.Id == Id) ?? new ServiceCenter();
            SetRedis(0, item.CategoryId);
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.ServiceCenter.Add(new ServiceCenter()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "ServiceCenter", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ServiceCenter data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "2"); //标题
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("CategoryId", "0");


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ServiceCenter", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["CategoryId"] = RelationClass.GetColInfo(int.Parse(dic["CategoryId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ServiceCenter", "ExportExcel");
            return Json(result);
        }

        #endregion





        #region 设置缓存

        private void SetRedis(int Id, int CategoryId)
        {
            if (CategoryId > 0)
            {
                RedisDbconn.Instance.Clear("ServiceCenterList");
                List<ServiceCenter> products = db.ServiceCenter.Where(m => m.Status > -1).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
                RedisDbconn.Instance.AddList("ServiceCenterList", products.ToArray());
            }
            if (Id > 0)
            {
                ServiceCenter edit = db.ServiceCenter.FirstOrDefault(m => m.Id == Id);
                if (edit != null)
                {
                    RedisDbconn.Instance.Set("ServiceCenter:" + Id, edit);
                }
            }
        }

        #endregion

    }
}
